package com.zanxiang.game.module.manage.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.zanxiang.game.module.manage.pojo.params.GameGiftPackLinkLogListParam;
import com.zanxiang.game.module.manage.pojo.vo.GameGiftPackLinkLogVO;
import com.zanxiang.game.module.manage.service.IGameGiftPackLinkLogService;
import com.zanxiang.game.module.mybatis.entity.GameGiftPackLinkLog;
import com.zanxiang.game.module.mybatis.mapper.GameGiftPackLinkLogMapper;
import com.zanxiang.module.util.bean.BeanUtil;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.LocalTime;

/**
 * @author : lingfeng
 * @time : 2022-06-22
 * @description : 游戏礼包码链接访问日志
 */
@Service
public class GameGiftPackLinkLogServiceImpl extends ServiceImpl<GameGiftPackLinkLogMapper, GameGiftPackLinkLog> implements IGameGiftPackLinkLogService {

    @Override
    public IPage<GameGiftPackLinkLogVO> list(GameGiftPackLinkLogListParam param) {
        return page(param.toPage(), new QueryWrapper<GameGiftPackLinkLog>().lambda()
                .eq(GameGiftPackLinkLog::getLinkId, param.getLinkId())
                .ge(param.getCreateBeginTime() != null, GameGiftPackLinkLog::getCreateTime, param.getCreateBeginTime() == null ? null : LocalDateTime.of(param.getCreateBeginTime(), LocalTime.MIN))
                .le(param.getCreateEndTime() != null, GameGiftPackLinkLog::getCreateTime, param.getCreateEndTime() == null ? null : LocalDateTime.of(param.getCreateEndTime(), LocalTime.MAX))
                .orderByDesc(GameGiftPackLinkLog::getCreateTime)
        ).convert(log -> BeanUtil.copy(log, GameGiftPackLinkLogVO.class));
    }

}




